/*
 * nologin.c - a login shell for disabling users.
 *
 * Copyright (c) 1997, 2001 Softweyr LLC, South Jordan, Utah USA.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY SOFTWEYR LLC AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL SOFTWEYR LLC OR ANY
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * Author: Wes Peters
 * Date: Tue Jan 28 21:30:06 MST 1997
 */

#include <sys/types.h>

#include <unistd.h>
#include <syslog.h>

int
main(int argc, char *argv[])
{
    int ch;
    char *user, *device;
    extern char *optarg;

    if ((user = getlogin()) == NULL)
        user = "UNKNOWN";

    if ((device = ttyname(0)) == NULL)
        device = "UNKNOWN";

    openlog("nologin", LOG_CONS, LOG_AUTH);
    syslog(LOG_CRIT, "%s on %s", user, device);
    closelog();

    while ((ch = getopt(argc, argv, "m:")) != -1)
    {
	switch (ch)
	{
	case 'm':
	    printf("%s: %s\n", user, optarg);
	    break;
	}
    }

    return 0;
}
